#version 430 core

in VertexData {
	vec3 position;
	vec3 normal;
	vec2 uv;
	vec3 tangent;
	vec3 bitangent;
} vert;

layout(binding = 0) uniform samplerCube shadowCubeMap;

uniform vec3 lightPosition;
uniform float farPlane;

layout(binding = 1) uniform sampler2D diffuseTex;

out vec4 color;


int numSamples = 20;

vec3 offsetDirections[20] = vec3[]
(
   vec3( 1,  1,  1), vec3( 1, -1,  1), vec3(-1, -1,  1), vec3(-1,  1,  1), 
   vec3( 1,  1, -1), vec3( 1, -1, -1), vec3(-1, -1, -1), vec3(-1,  1, -1),
   vec3( 1,  1,  0), vec3( 1, -1,  0), vec3(-1, -1,  0), vec3(-1,  1,  0),
   vec3( 1,  0,  1), vec3(-1,  0,  1), vec3( 1,  0, -1), vec3(-1,  0, -1),
   vec3( 0,  1,  1), vec3( 0, -1,  1), vec3( 0, -1, -1), vec3( 0,  1, -1)
);  



float CalculateShadow(vec3 vertexPosition) {
		
	/*float nearestDepth = texture(shadowCubeMap, normalize(vertexPosition - lightPosition)).r;	
	
	nearestDepth = nearestDepth * farPlane;

	if (length(vertexPosition - lightPosition) - 0.05 > nearestDepth) {
		return 0.0;
	}

	return 1.0;*/



	float shadow = 0.0;

	//float radius = (1.0 + (length(vertexPosition - lightPosition) / farPlane)) / 300.0; 

	for (int i = 0; i < numSamples; i++){
		float nearestDepth = texture(shadowCubeMap, normalize(vertexPosition - lightPosition) + offsetDirections[i] * 0.008).r;	
		nearestDepth = nearestDepth * farPlane;

		if ((length(vertexPosition - lightPosition) - 0.4) < nearestDepth) {
			shadow = shadow + 1.0;
		}
	}

	return (shadow / numSamples);
}

void main() {	

	float shadow = CalculateShadow(vert.position);

	color = texture(diffuseTex, vert.uv).rgba * shadow;

	/*float diffuse;
	float ambient = 0.4;
	float specular = 0.0;

	vec3 lightDirection = normalize(vec3(1.0, 1.0, 1.0));
	float lightDir = max(dot(lightDirection, vert.normal), 0.0);
	
	vec3 textureColor = texture(diffuseTex, vert.uv).rgb;*/

	//color = vec4(textureColor * ((ambient * /*textureColor.xyz*/lightDirection) + shadow * (diffuse + specular)), texture(diffuseTex, vert.uv).a);
}