#version 430 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;
layout(location = 3) in vec3 tangent;
layout(location = 4) in vec3 bitangent;

out VertexData {
	vec3 position;
	vec3 normal;
	vec2 uv;
	vec3 tangent;
	vec3 bitangent;
} vert;

uniform mat4 VP;

void main() {
	vert.position = position;
	vert.normal = normal;
	vert.uv = uv;
	vert.tangent = tangent;
	vert.bitangent = bitangent;
	gl_Position = VP * vec4(position, 1);
}