#version 430 core

layout(binding = 0) uniform sampler2D uTexSampler;
layout(binding = 1) uniform sampler2D uDepthSampler;

uniform float near = 0.1;
uniform float far = 1000.0;

in VertexData
{
	vec2 uvCoords;   
} fs_in;

out vec4 oFragColor;

void main()
{ 
    vec4 texColor = texture(uDepthSampler, fs_in.uvCoords);
	float depth = texColor.r * 2.0 - 1.0;
	float linearDepth = (2.0 * near * far) / (far + near - depth * (far - near));
	oFragColor = vec4(texColor.r* 2.0 - 1.0, 0.0, 0.0, 1.0);
	//oFragColor = vec4(fs_in.uvCoords.x, fs_in.uvCoords.y, 0.0, 1.0);
}